/*
 * Cosmos - an xscreensaver module.
 * Tom Campbell and Jim Tanner Oct 2000 <campbell@mindspring.com>
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The author
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the author be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 *
 * Portions of this software were inspired by the late Seumas MacNally.
 * http://www.gamedev.net/community/memorial/seumas/
 *
 */


#include "explodescript.h"
#include <string>
#include <math.h>

CExplodeScript::CExplodeScript()
{
}

void CExplodeScript::Follow(CCast *cast)
{
  	if (cast->count > cast->blastcount) {
		int x=random()%CCosmos::GetInstance()->getWidth();
		int y=random()%CCosmos::GetInstance()->getHeight();
		for (int i=0;i<CCosmos::GetInstance()->actorcount;i++) {
			cast->actors[i]->Reset(x,y,cast->script);
		}
		cast->count = 0;
	}
	for(unsigned int i=0;i<cast->actors.size();i++)
	  NextPosition(cast->actors[i]);
}


void CExplodeScript::NextPosition(CActor *me)
{
	int _SPEED=SPEED;

	if (me->m_init==0) {
		me->m_x = CCosmos::GetInstance()->getWidth()/2;
		me->m_y = CCosmos::GetInstance()->getHeight()/2;
		me->m_count = 0;
		me->m_init=1;
	}

	_SPEED = SPEED /3;

	if (!me->m_count) {
	calc:         

		me->m_xdelta = (random()%(_SPEED*10) - ((_SPEED*10.0)-1)/2.0)/10.0;
		me->m_ydelta = (random()%(_SPEED*10) - ((_SPEED*10.0)-1)/2.0)/10.0;
		if ((sqrt(me->m_xdelta*me->m_xdelta + me->m_ydelta*me->m_ydelta ) > _SPEED/2) && me->m_follow) {
			goto calc;
		}
	}

#ifdef WRAP
	if (((m_x+m_xdelta) > (WIDTH-2)) || ((m_x+m_xdelta) < 2))
		m_xdelta *= -1;
#else
	if (me->m_x > CCosmos::GetInstance()->getWidth()) {
		me->m_x -= CCosmos::GetInstance()->getWidth();
		me->m_y++;
	}
	if (me->m_x < 0) {
		me->m_x += CCosmos::GetInstance()->getWidth();
		me->m_y--;
	}
#endif
	if (((me->m_y+me->m_ydelta) > CCosmos::GetInstance()->getHeight()-4) || ((me->m_y+me->m_ydelta) < 4)) {
		me->m_ydelta *= -1.0;
		me->m_ydelta += random()%3-2.0;
	}

	CCosmos::GetInstance()->DrawLine((int)me->m_x,(int)me->m_y,(int)(me->m_x+me->m_xdelta),(int)(me->m_y+me->m_ydelta),253);
	me->m_x += me->m_xdelta;
	me->m_y += me->m_ydelta;
	if (!me->m_visible && me->m_y < 0) { 
		me->m_ydelta += 0.22;
	}
	if (!me->m_visible && me->m_y > CCosmos::GetInstance()->getHeight()) {
		me->m_ydelta -= 0.22;
	}

	me->m_count++;
	me->m_TotalClicks++;
		
	if (me->m_count > 1000) {
		me->m_count = 0;
	}
}

char* CExplodeScript::ScriptType(void)
{
  return("explode");
}
